unit ituMainForm;

{$mode Delphi}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, LCLIntf, LMessages,
  ExtCtrls;

const
  WM_FINALIZE = LM_USER + 2000;
  WM_DO_ACTION_MENU = LM_USER + 2001;

type

  { TitMainForm }

  TitMainForm = class(TForm)
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  protected
    procedure Finalize(var Msg: TLMessage); message WM_FINALIZE;
    procedure DoMenuAction(var Msg: TLMessage); message WM_DO_ACTION_MENU;

  public

  end;

  { TDLLThread }

  TDLLThread = class(TThread)
  public
    StarUMLApplication: TObject;
  protected
    procedure Execute; override;
  end;

var
  itMainForm: TitMainForm;
  DLLMainThread: TDLLThread;

implementation

{$R *.lfm}

uses Win32Int, Win32Proc, Windows, ActiveX,
     LazUTF8, DelphiAddInObj, StarUMLintf, IntegracaoDelphiSUML;

procedure CreateAppHandle;
var
  SysMenu: HMENU;
begin
  Win32WidgetSet.AppHandle := CreateWindowW(@ClsNameW,
    PWideChar(UTF8ToUTF16(Application.Title)),
    WS_POPUP or WS_CLIPSIBLINGS or WS_SYSMENU or WS_MINIMIZEBOX,
    0, {Windows.GetSystemMetrics(SM_CXSCREEN) div 2,}
    0, {Windows.GetSystemMetrics(SM_CYSCREEN) div 2,}
    0, 0, HWND(nil), HMENU(nil), HInstance, nil);
  AllocWindowInfo(Win32WidgetSet.AppHandle);
  // remove useless menuitems from sysmenu
  SysMenu := Windows.GetSystemMenu(Win32WidgetSet.AppHandle, False);
  Windows.DeleteMenu(SysMenu, SC_MAXIMIZE, MF_BYCOMMAND);
  Windows.DeleteMenu(SysMenu, SC_SIZE, MF_BYCOMMAND);
  Windows.DeleteMenu(SysMenu, SC_MOVE, MF_BYCOMMAND);
end;

{ TitMainForm }

procedure TitMainForm.Timer1Timer(Sender: TObject);
begin
  timer1.Enabled := false;
  itMainForm.Hide;
end;

procedure TitMainForm.FormCreate(Sender: TObject);
begin
end;

procedure TitMainForm.Finalize(var Msg: TLMessage);
begin
  gStarUMLApp := Nil;
  self.Close;
end;

procedure TitMainForm.DoMenuAction(var Msg: TLMessage);
begin
  try
    TDelphiAddInObj.DoMenuAction(Msg.wParam);
  except
    on E: Exception do
    begin
      Application.MessageBox(PAnsiChar(e.Message), 'Error...', MB_ICONERROR);
    end;
  end;
end;

{ TDLLThread }

procedure TDLLThread.Execute;
begin
  CoInitialize(nil);
  StarUMLApplication.GetInterface(IID_IStarUMLApplication, gStarUMLApp);
  Application.ExceptionDialog := aedOkMessageBox;
  Application.Initialize;
  CreateAppHandle;
  Application.CreateForm(TitMainForm, itMainForm);
  Application.Run;
  CoUninitialize;
end;

end.

